%This script can reproduce the Numerical Example I in the paper (OMP outputs)
%It compares OMP and HBW-OMP strategies for approximating partitions.
%By default it runs for Cos-Sin dictionary redundancy 4
%Please change the file Get_Example_I_OMP_Settings, as indicated there, to reproduce 
%Table 1 in the paper
%
%load the signal
[wave,fs]=audioread('Cooperative/Signals/pno-cs.wav');
signal=wave(:,1); %convert to mono channel

Get_Example_I_OMP_Settings

%
[s1,s2]=size(signal);
if s1< s2; signal=signal';end
bw=FrameLength;
%
%
[cmf,Nframe,mf]=BlockSignal(signal,bw); %makes the partition
%======end the segmentation each cmf is a cell 
tic
delta=1;
%
indx=[]; %do not touch 
%
[FrameLength, N]=size(D);
%
%Caculate the phaces to calculate inner products with fft (eq      )
clear eex
M=N;
if icase==4 M=N/2;end  %cosine \cup sin dictionary
k=1:M;
if icase==2 | icase ==4 % icase 2 cosine dictionary
eex(1,:)=exp(-pi*1i*(k-1)/(2*M))./nord(1,:);
end
if icase==3 %sine dictionary
eex(1,:)=exp(-pi*1i*(k)/(2*M))./nord(1,:);
end
if icase==4  
eex(2,:)=exp(-pi*1i*(k)/(2*M))./nord(2,:);
end

No=bw;
mfc=cell(Nframe,1);
c1=cell(Nframe,1);
nCoe=0;
zero_frame=0;
%
%=============Start the approxiamtion of each block=========
%
clear c0 D0 Di0 beta0 c0 Q0 h cbeta cQ cD c cDi1 
tic;
for j=1:Nframe;
%cmf{j}=cmf{j}';
tol=sqrt(norm(cmf{j})^2/(10^(pss/10)));
if (norm(cmf{j})^2)*delta>1e-11 %avoids to approximate zero block
%
[h{j},cDi1{j},beta,c{j},cQ]=OMP_FFT(cmf{j},D,tol,No,indx,eex,icase);%
%
%======== save the coefficients 'c' and indices 'cDi1' and approximated blocks 'h'
k0=numel(c{j});
nCoe = nCoe + k0; %number of coeffients in the frames
else
%h{j}=zeros(bw,1); %zero frame
nCoe = nCoe + 1;     %counts 1 coefficient (zero) per zero frame
zero_frame=zero_frame+1; %numbers of zero frame
end
end
%
%=====================================================================
clear msignal
fa=[];
for i=1:Nframe
%h{i}=h{i}'; %uncomment if tunning OMP_mtestFFT
cmf{i}=cmf{i}';
fa=[fa h{i}];%get the whole signal from the frames 
end
%
fprintf('===============================================\n')
;

 fprintf('OMP Sparsity Ratio SR.\n');

SR= numel(mf)/nCoe% Sparsity ratio
No=nCoe %numer of atoms

fprintf('OMP Approximation quality SNR.\n');

SNR= CalcSNR(mf,fa)

toc
tol3=0;
tic
%
[h,cDi1,cbeta,c,Q,Nat]=OHBW_OMP_FFT(cmf,D,tol3,No,eex,icase);
%
%=====================================================================
fa=[];
for i=1:Nframe
fa=[fa;h{i}];%assemble the signal from the blocks 
end
fprintf('===============================================\n')
;

fprintf('HBW-OMP Sparsity Ratio SR.\n');
%
SR_hwb= numel(mf)/Nat% Sparsity ratio
%MSE=norm(mf-fa)^2/numel(mf) % of the approximation
nCoe=Nat
fprintf('HBW-OMP Approximation quality SNR.\n');
SNR_hbw= CalcSNR(mf',fa)
toc

fprintf('===============================================\n')
;

toc


