function [D nord]=get_trig_dict(Lx,a,icase);

%generates a tigonometric dictionary D
%icase =2, cosine (a=1 is ortho DCT)
%icase =3, sine (a=1 is ortho DST)
%icase =4  cosine/sine (a=0.5 is ortho  DCT and DST)


switch icase

case 2

dre=DCos(Lx,a*Lx,a); %creates dictionry of cosines
for i=1:a*Lx; nord(1,i)=norm(dre(:,i));end
D=NormDict(dre); 

case 3

dim=DSin(Lx,a*Lx,a); %creates dictionry of sines
for i=1:a*Lx; nord(1,i)=norm(dim(:,i));end
D=NormDict(dim);

case 4

dre=DCos(Lx,a*Lx,a); %creates dictionry of cosines
for i=1:a*Lx; nord(1,i)=norm(dre(:,i));end
dre=NormDict(dre);   %normalize the dictionry
%

dim=DSin(Lx,a*Lx,a); %creates dictionaries of sines
for i=1:a*Lx; nord(2,i)=norm(dim(:,i));end
dim=NormDict(dim);

D=[dre dim]; %creates cosine/sine dictionary

end



